# IO.Swagger - the C# library for the Swagger Petstore

This is a sample Petstore server.  You can find out more about Swagger at [http://swagger.io](http://swagger.io) or on [irc.freenode.net, #swagger](http://swagger.io/irc/). 

This C# SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- SDK version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.dotnet.CsharpDotNet2ClientCodegen

<a name="frameworks-supported"></a>
## Frameworks supported
- .NET 2.0

<a name="dependencies"></a>
## Dependencies
- Mono compiler
- Newtonsoft.Json.7.0.1
- RestSharp.Net2.1.1.11

Note: NuGet is downloaded by the mono compilation script and packages are installed with it. No dependency DLLs are bundled with this generator

<a name="installation"></a>
## Installation
Run the following command to generate the DLL
- [Mac/Linux] `/bin/sh compile-mono.sh`
- [Windows] TODO

Then include the DLL (under the `bin` folder) in the C# project, and use the namespaces:
```csharp
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;
```
<a name="getting-started"></a>
## Getting Started

```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class Example
    {
        public void main()
        {


            var apiInstance = new DefaultApi();

            try
            {
                List<Test> result = apiInstance.TestMethod();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DefaultApi.TestMethod: " + e.Message );
            }
        }
    }
}
```

<a name="documentation-for-api-endpoints"></a>
## Documentation for API Endpoints

All URIs are relative to */*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**TestMethod**](docs/DefaultApi.md#testmethod) | **GET** /test | 
*PetApi* | [**AddParrot**](docs/PetApi.md#addparrot) | **POST** /parrot | Add a new parrow to the store
*PetApi* | [**AddPet**](docs/PetApi.md#addpet) | **POST** /pet | Add a new pet to the store
*PetApi* | [**DeletePet**](docs/PetApi.md#deletepet) | **DELETE** /pet/{petId} | Deletes a pet
*PetApi* | [**FeedPet**](docs/PetApi.md#feedpet) | **POST** /pet/feed/{petId} | Find pet by ID
*PetApi* | [**FindPetsByStatus**](docs/PetApi.md#findpetsbystatus) | **GET** /pet/findByStatus | Finds Pets by status
*PetApi* | [**FindPetsByTags**](docs/PetApi.md#findpetsbytags) | **GET** /pet/findByTags | Finds Pets by tags
*PetApi* | [**GetParrots**](docs/PetApi.md#getparrots) | **GET** /parrot | get Parrots
*PetApi* | [**GetPetById**](docs/PetApi.md#getpetbyid) | **GET** /pet/{petId} | Find pet by ID
*PetApi* | [**UpdateParrots**](docs/PetApi.md#updateparrots) | **PUT** /parrot | update parrots
*PetApi* | [**UpdatePet**](docs/PetApi.md#updatepet) | **PUT** /pet | Update an existing pet
*PetApi* | [**UpdatePetWithForm**](docs/PetApi.md#updatepetwithform) | **POST** /pet/{petId} | Updates a pet in the store with form data
*PetApi* | [**UploadFile**](docs/PetApi.md#uploadfile) | **POST** /pet/{petId}/uploadImage | uploads an image
*StoreApi* | [**DeleteOrder**](docs/StoreApi.md#deleteorder) | **DELETE** /store/order/{orderId} | Delete purchase order by ID
*StoreApi* | [**GetInventory**](docs/StoreApi.md#getinventory) | **GET** /store/inventory | Returns pet inventories by status
*StoreApi* | [**GetOrderById**](docs/StoreApi.md#getorderbyid) | **GET** /store/order/{orderId} | Find purchase order by ID
*StoreApi* | [**PlaceOrder**](docs/StoreApi.md#placeorder) | **POST** /store/order | Place an order for a pet
*UserApi* | [**CreateUser**](docs/UserApi.md#createuser) | **POST** /user | Create user
*UserApi* | [**CreateUsersWithArrayInput**](docs/UserApi.md#createuserswitharrayinput) | **POST** /user/createWithArray | Creates list of users with given input array
*UserApi* | [**CreateUsersWithListInput**](docs/UserApi.md#createuserswithlistinput) | **POST** /user/createWithList | Creates list of users with given input array
*UserApi* | [**DeleteUser**](docs/UserApi.md#deleteuser) | **DELETE** /user/{username} | Delete user
*UserApi* | [**GetUserByName**](docs/UserApi.md#getuserbyname) | **GET** /user/{username} | Get user by user name
*UserApi* | [**LoginUser**](docs/UserApi.md#loginuser) | **GET** /user/login | Logs user into the system
*UserApi* | [**LogoutUser**](docs/UserApi.md#logoutuser) | **GET** /user/logout | Logs out current logged in user session
*UserApi* | [**UserUsernamePut**](docs/UserApi.md#userusernameput) | **PUT** /user/{username} | Updated user

<a name="documentation-for-models"></a>
## Documentation for Models

 - [IO.Swagger.Model.AllPetsResponse](docs/AllPetsResponse.md)
 - [IO.Swagger.Model.AnyOfbody1ParrotsItems](docs/AnyOfbody1ParrotsItems.md)
 - [IO.Swagger.Model.AnyOfbody2](docs/AnyOfbody2.md)
 - [IO.Swagger.Model.ApiResponse](docs/ApiResponse.md)
 - [IO.Swagger.Model.Body](docs/Body.md)
 - [IO.Swagger.Model.Body1](docs/Body1.md)
 - [IO.Swagger.Model.Body2](docs/Body2.md)
 - [IO.Swagger.Model.Cat](docs/Cat.md)
 - [IO.Swagger.Model.Category](docs/Category.md)
 - [IO.Swagger.Model.Dog](docs/Dog.md)
 - [IO.Swagger.Model.InlineResponse200](docs/InlineResponse200.md)
 - [IO.Swagger.Model.InlineResponse2001](docs/InlineResponse2001.md)
 - [IO.Swagger.Model.Macaw](docs/Macaw.md)
 - [IO.Swagger.Model.OneOfAllPetsResponseItems](docs/OneOfAllPetsResponseItems.md)
 - [IO.Swagger.Model.OneOfPartMasterDestination](docs/OneOfPartMasterDestination.md)
 - [IO.Swagger.Model.OneOfPartMasterOrigin](docs/OneOfPartMasterOrigin.md)
 - [IO.Swagger.Model.OneOfPetPartItems](docs/OneOfPetPartItems.md)
 - [IO.Swagger.Model.OneOfPup](docs/OneOfPup.md)
 - [IO.Swagger.Model.OneOfinlineResponse2001](docs/OneOfinlineResponse2001.md)
 - [IO.Swagger.Model.OneOfinlineResponse200ParrotsItems](docs/OneOfinlineResponse200ParrotsItems.md)
 - [IO.Swagger.Model.OneOfvalMembersValMemberItems](docs/OneOfvalMembersValMemberItems.md)
 - [IO.Swagger.Model.Order](docs/Order.md)
 - [IO.Swagger.Model.Parakeet](docs/Parakeet.md)
 - [IO.Swagger.Model.PartFour](docs/PartFour.md)
 - [IO.Swagger.Model.PartMaster](docs/PartMaster.md)
 - [IO.Swagger.Model.PartOne](docs/PartOne.md)
 - [IO.Swagger.Model.PartThree](docs/PartThree.md)
 - [IO.Swagger.Model.PartTwo](docs/PartTwo.md)
 - [IO.Swagger.Model.Pet](docs/Pet.md)
 - [IO.Swagger.Model.Pup](docs/Pup.md)
 - [IO.Swagger.Model.Tag](docs/Tag.md)
 - [IO.Swagger.Model.Test](docs/Test.md)
 - [IO.Swagger.Model.User](docs/User.md)
 - [IO.Swagger.Model.ValMemberChoice1](docs/ValMemberChoice1.md)
 - [IO.Swagger.Model.ValMemberChoice2](docs/ValMemberChoice2.md)
 - [IO.Swagger.Model.ValMembers](docs/ValMembers.md)

<a name="documentation-for-authorization"></a>
## Documentation for Authorization

<a name="api_key"></a>
### api_key

- **Type**: API key
- **API key parameter name**: api_key
- **Location**: HTTP header

<a name="bearer"></a>
### bearer


<a name="petstore_auth"></a>
### petstore_auth

- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: http://petstore.swagger.io/oauth/dialog
- **Scopes**: 
  - : 

